searchNodes=[{"doc":"CubQ is a queue abstraction on top of CubDB. It implements persistent local (double-ended) queue and stack semantics. Usage CubQ is given a CubDB process and a queue identifier upon start: {:ok, db} = CubDB.start_link(data_dir: &quot;my/data/directory&quot;) {:ok, pid} = CubQ.start_link(db: db, queue: :my_queue_id) Queues Queue semantics are implemented by the enqueue/2 and dequeue/1 functions: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :two} # When there are no more items in the queue, [`dequeue/1`](#dequeue/1) returns `nil`: CubQ.dequeue(pid) #=&gt; nil Note that items can be any Elixir (or Erlang) term: CubQ.enqueue(pid, %SomeStruct{foo: &quot;bar&quot;}) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, %SomeStruct{foo: &quot;bar&quot;}} The queue is actually double-ended, so items can be prepended too: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.prepend(pid, :zero) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :zero} Stacks Stack semantics are implemented by the push/2 and pop/1 functions: CubQ.push(pid, :one) #=&gt; :ok CubQ.push(pid, :two) #=&gt; :ok CubQ.pop(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :one} # When there are no more items in the stack, [`pop/1`](#pop/1) returns `nil`: CubQ.pop(pid) #=&gt; nil Mixing things up As the underlying data structure used for stacks and queues is the same, queue and stack semantics can be mixed on the same queue.","ref":"CubQ.html","title":"CubQ","type":"module"},{"doc":"Positively acknowledges the successful consumption of an item taken with dequeue_ack/2 or pop_ack/2. See the documentation for dequeue_ack/2 for more details.","ref":"CubQ.html#ack/2","title":"CubQ.ack/2","type":"function"},{"doc":"Same as enqueue/2","ref":"CubQ.html#append/2","title":"CubQ.append/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"CubQ.html#child_spec/1","title":"CubQ.child_spec/1","type":"function"},{"doc":"Deletes all items from the queue. The items are deleted in batches, and the size of the batch can be specified as the optional second argument.","ref":"CubQ.html#delete_all/2","title":"CubQ.delete_all/2","type":"function"},{"doc":"Removes an item from the beginning of the queue and returns it. It returns {:ok, item} if there are items in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :two}","ref":"CubQ.html#dequeue/1","title":"CubQ.dequeue/1","type":"function"},{"doc":"Removes an item from the beginning of the queue and returns it, expecting a manual confirmation of its successful processing with ack/2. If ack/2 is not called before timeout, the item is put back at the beginning of the queue. The dequeue_ack/2 function is useful when implementing &quot;at least once&quot; semantics, especially when more than one consumer takes items from the same queue, to ensure that each item is successfully consumed before being discarded. The problem is the following: if a consumer took an item with dequeue/1 and then crashes before processing it, the item would be lost. With dequeue_ack/2 instead, the item is not immediately removed, but instead atomically transfered to a staging storage. If the consumer successfully processes the item, it can call ack/2 (acknowledgement) to confirm the success, after which the item is discarded. If ack/2 is not called within the timeout (expressed in milliseconds, 5000 by default), the item is automatically put back to the queue, so it can be dequeued again by a consumer. If the consumer wants to put back the item to the queue immediately, it can also call nack/2 (negative acknowledgement) explicitly. The return value of dequeue_ack/2 is a 3-tuple: {:ok, item, ack_id}. The ack_id is the argument that must be passed to ack/2 or nack/2 to confirm the successful (or insuccessful) consumption of the item. Note that dequeue_ack/2 performs its operation in an atomic and durable way, so even if the CubQ process crashes, after restarting it will still re-insert the items pending acknowledgement in the queue after the timeout elapses. After restarting though, the timeouts are also restarted, so the effective time before the item goes back to the queue can be larger than the original timeout. In case of timeout or negative acknowledgement, the item is put back in the queue from the start, so while global ordering cannot be enforced in case of items being put back to the queue, the items will be ready to be dequeued again immediately after being back to the queue. Example CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok {:ok, item, ack_id} = CubQ.dequeue_ack(pid, 3000) #=&gt; {:ok, :one, ack_id} # More items can be now taken from the queue CubQ.dequeue(pid) #=&gt; {:ok, :two} # If 3 seconds elapse without `ack` being called, or `nack` is called, # the item `:one` would be put back to the queue, so it can be dequeued # again: CubQ.nack(pid, ack_id) #=&gt; :ok {:ok, item, ack_id} = CubQ.dequeue_ack(pid, 3000) #=&gt; {:ok, :one, ack_id} # When successful consumption is confirmed by calling `ack`, the item # is finally discarded and won&#39;t be put back in the queue anymore: CubQ.ack(pid, ack_id) #=&gt; :ok","ref":"CubQ.html#dequeue_ack/2","title":"CubQ.dequeue_ack/2","type":"function"},{"doc":"Inserts an item at the end of the queue. The item can be any Elixir (or Erlang) term. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#enqueue/2","title":"CubQ.enqueue/2","type":"function"},{"doc":"Negatively acknowledges an item taken with dequeue_ack/2 or pop_ack/2, causing it to be put back in the queue. See the documentation for dequeue_ack/2 for more details.","ref":"CubQ.html#nack/2","title":"CubQ.nack/2","type":"function"},{"doc":"Returns the item at the beginning of the queue without removing it. It returns {:ok, item} if there are items in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.peek_first(pid) #=&gt; {:ok, :one} CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#peek_first/1","title":"CubQ.peek_first/1","type":"function"},{"doc":"Returns the item at the end of the queue without removing it. It returns {:ok, item} if there are items in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.enqueue(pid, :two) #=&gt; :ok CubQ.peek_last(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :two}","ref":"CubQ.html#peek_last/1","title":"CubQ.peek_last/1","type":"function"},{"doc":"Removes an item from the end of the queue and returns it. It returns {:ok, item} if there are items in the queue, nil if the queue is empty, and {:error, cause} on error. Example: CubQ.push(pid, :one) #=&gt; :ok CubQ.push(pid, :two) #=&gt; :ok CubQ.pop(pid) #=&gt; {:ok, :two} CubQ.pop(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#pop/1","title":"CubQ.pop/1","type":"function"},{"doc":"Removes an item from the end of the queue and returns it, expecting a manual confirmation of its successful processing with ack/2. If ack/2 is not called before timeout, the item is put back at the end of the queue. See the documentation for dequeue_ack/2 for more details: the pop_ack/2 function works in the same way as dequeue_ack/2, but with stack semantics instead of queue semantics.","ref":"CubQ.html#pop_ack/2","title":"CubQ.pop_ack/2","type":"function"},{"doc":"Inserts an item at the beginning of the queue. The item can be any Elixir (or Erlang) term. Example: CubQ.enqueue(pid, :one) #=&gt; :ok CubQ.prepend(pid, :zero) #=&gt; :ok CubQ.dequeue(pid) #=&gt; {:ok, :zero} CubQ.dequeue(pid) #=&gt; {:ok, :one}","ref":"CubQ.html#prepend/2","title":"CubQ.prepend/2","type":"function"},{"doc":"Same as enqueue/2. Normally used together with pop/1 for stack semantics.","ref":"CubQ.html#push/2","title":"CubQ.push/2","type":"function"},{"doc":"Starts a CubQ process without link. The argument is a keyword list of options, see start_link/1 for details.","ref":"CubQ.html#start/1","title":"CubQ.start/1","type":"function"},{"doc":"Starts a CubQ process linked to the calling process. The argument is a keyword list of options: db (required): the pid (or name) of the CubDB process for storing the queue queue (required): the identifier of the queue. It can be any Elixir term, but typically one would use an atom, like :my_queue GenServer options like name and timeout can also be given, and are forwarded to GenServer.start_link/3 as the third argument.","ref":"CubQ.html#start_link/1","title":"CubQ.start_link/1","type":"function"},{"doc":"","ref":"CubQ.html#t:ack_id/0","title":"CubQ.ack_id/0","type":"opaque"},{"doc":"","ref":"CubQ.html#t:item/0","title":"CubQ.item/0","type":"type"},{"doc":"","ref":"CubQ.html#t:option/0","title":"CubQ.option/0","type":"type"},{"doc":"","ref":"CubQ.State.html","title":"CubQ.State","type":"module"},{"doc":"","ref":"CubQ.State.html#t:t/0","title":"CubQ.State.t/0","type":"type"}]